﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.IO;
using Newtonsoft.Json;

namespace AR_RuntimeDataSource
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            GrapeCity.ActiveReports.PageReport rpt = new GrapeCity.ActiveReports.PageReport();
            rpt.Load(new FileInfo("../../MainReport.rdlx"));
            rpt.Document.LocateDataSource += Document_LocateDataSource;

            viewer1.LoadDocument(rpt.Document);
        }

        private void Document_LocateDataSource(object sender, GrapeCity.ActiveReports.LocateDataSourceEventArgs args)
        {
            if (args.Report.Name.Contains("MainReport.rdlx"))
            {
                using (StreamReader r = new StreamReader("../../customers.json"))
                {
                    string json = r.ReadToEnd();
                    CustomerData customers = JsonConvert.DeserializeObject<CustomerData>(json);

                    args.Data = customers.Customers;
                }
            }
            else if (args.Report.Name.Contains("SubReport.rdlx"))
            {
                using (StreamReader r = new StreamReader("../../customers.json"))
                {
                    string json = r.ReadToEnd();
                    CustomerData customers = JsonConvert.DeserializeObject<CustomerData>(json);

                    args.Data = customers.Customers;
                }
            }
        }
    }

    public class CustomerData
    {
        public List<Customer> Customers { get; set; }
    }

    public class Customer
    {
        public string Id { get; set; }
        public string CompanyName { get; set; }
        public string ContactName { get; set; }
        public string City { get; set; }
    }
}
